
/*
// A polymorph list
// index-range: [0-n[ , where n is the number of elements !
//
// the elements of the list MUST have a rtti-structure at the beginning
// of the memory-structure AND the rtti-type MUST be a global valid
// rtti-type ( see rtti.h ) !!!
//
// The CListe will be registered in the rtti-module
// once automatic with the first 'CListe_Create' call !!!!!
// But you are able to register CListe automatic,
// by calling the 'CListeRegisterRtti' function !!!!!!!!!!!

//
// Because of the registration of the CListe in the rtti-module,
// all CListe-objects can be create, copied, assigned and
// destroyed via the ...Rtti functions DEEP and recursiv !!!!!!!
// You can see, object-orientated C++ support is avaiable !!!!!!
// ( see rtti.h )
//
// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
*/

#ifndef _cliste_h
  #define _cliste_h

  #ifndef __CLISTE__
    typedef void * HCListe;
    #define __CLISTE__
  #endif

  #define C_HCLISTE(a) ((HCListe)(a))

  #include <string.h>
  #include <stdlib.h>
  #include "rtti.h"


  #include "interror.h"

  const rtti * const GetRttiCListe(void);
  const rtti * const CListeRegisterRtti       (void);

  int     CListe_Laenge          (const HCListe lh);
  void    CListe_Destroy        (HCListe lh);
  void    CListe_Clear          (HCListe lh);
  rtti  * CListe_Create          (void);
  rtti  * CListe_CopyCreate      (const HCListe lh);
  int     CListe_IsEqual        (const HCListe LhA, const HCListe LhB);
  int     CListe_FuegeEin        (HCListe lh, const rtti *elem, int i);
  void     CListe_Loesche        (HCListe lh, int i);
  rtti   *CListe_GetElement      (const HCListe lh, int i);
  int     CListe_IstElement      (const HCListe lh, const rtti * element, int i);
  int     CListe_Referenz2Index  (const HCListe lh, const rtti * element);

  /* returns the whole - deep memory usage of lh */
  unsigned long  CListe_GetMemoryUsage(const HCListe lh);

  /* For assignment call AssignRtti (...) !!!!!!!!!!!!!
     there is no more :
     'HCListe CListe_Assign          (HCListe DestLh, const HCListe SrcLh);'
  */

# endif
