/*
// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
*/
#include "memgetc.h"

static const BYTE *InputBuffer=NULL;
static unsigned long InputBufferPos;
static unsigned long InputBufferLen;

static const BYTE *OutputBuffer=NULL;
static unsigned long OutputBufferPos;
static unsigned long OutputBufferLen;

static int TestInit(const char *InBuffer, char *OutBuffer)
{
  if( (InBuffer!=NULL && InputBuffer!=InBuffer) ||
      (OutBuffer!=NULL && OutputBuffer!=OutBuffer)
    )
  {
    ErrorOut("Error: a mem as io function is called, but isn't initialized !\n");
    INT_ERR(__LINE__); /* not initialised ? */
    return 0;
  }
	return 1;
}

void InitMemAsIO(const BYTE *inmem, unsigned long inlength,
                 BYTE *outmem, unsigned long outlength)
{
  InputBuffer=inmem;
  InputBufferPos=0;
  InputBufferLen=inlength;
  OutputBuffer=outmem;
  OutputBufferPos=0;
  OutputBufferLen=outlength;
}

void InitMemGetC(const BYTE *mem, unsigned long length)
{
  InputBuffer=mem;
  InputBufferPos=0;
  InputBufferLen=length;
}

int memgetc(const BYTE *mem)
{
  #ifndef NDEBUG
    long l_test;
    BYTE *ptrTest=NULL;
    BYTE c_test;
  #endif

  if(TestInit(InputBuffer,NULL)==0)
  {
    return EOF;
  }
  else
  {
    if(InputBufferLen<=InputBufferPos+1) return EOF;
    if(sizeof(long)>=sizeof(BYTE *))
    {
      #ifndef _C166_
        #ifndef NDEBUG
          l_test=((long)InputBuffer+(InputBufferPos++));
          /* pointer fehler */
          ptrTest=(BYTE *)l_test;
          c_test=*ptrTest;
          return c_test;
        #else
          return * ( (BYTE *) ( (long)InputBuffer+(InputBufferPos++) ) ) ;
        #endif
      #else
        return ( * ((BYTE *) ( InputBuffer+(InputBufferPos++) )) ) & 0x00FF;
      #endif
    }
    else
      return InputBuffer[(int)(InputBufferPos++)] & 0x00FF;
  }
}

int mem_getc(const BYTE *mem)
{
  return memgetc(mem);
}

int  mem_printf(char *Buffer, const char *fmt, ... )
{
  va_list va;
  char _Buffer[512];
  unsigned short result;

  if(TestInit(NULL, Buffer)==0)
  {
    return EOF;
  }

  va_start(va, fmt);
  vsprintf(_Buffer, fmt, va);

  result = rc_write(hdle, Buffer, strlen(Buffer));

  va_end(va);
  return result;
}

mem_puts
mem_putc
