/*************************************************************************/
/*
 *  Datei          : metageom.h
 *  Programmierer  : Sven Goethel
 *            Stapenhorststr.35a
 *            33615 Bielefeld
 *            0521/139228
 *
 * $Log: metageom.h $
 * Revision 1.2  1995/04/07 16:54:54  Sven_Goethel_DFP
 * *** empty log message ***
 * Revision 1.1  1995/04/04 10:37:31  Sven_Goethel
 * Initial revision
 */
/*************************************************************************/

# ifndef _METAGEOM_H
  # define _METAGEOM_H

  # include "metatype.h"
  # include <math.h>

	void MGeom_AddWinkel(t_real *result, const t_real *a, const t_real *b);
	void MGeom_SubWinkel(t_real *result, const t_real *a, const t_real *b);


	void MGeom_KreisLaenge(t_real *result, const t_coord *P0, const t_coord *PM,
				                 const t_coord *P1, t_rotation rot);

	void MGeom_VektorBetrag(t_real *result, const t_coord *P1, const t_coord *P2);

	void MGeom_GetWinkelAbsolutPPR(t_real *result, const t_coord *Pp, 
	                               const t_coord *PM, t_rotation Rot);
	void MGeom_GetWinkelAbsolutPP(t_real *result, const t_coord *P0, 
	                              const t_coord *P1);

	void MGeom_GetWinkel12 ( t_real *result, const t_coord *P0, const t_coord *P1,
													 const t_coord *P2 );

	void MGeom_GetWinkel12PPPR ( t_real *result, const t_coord *P0, 
														   const t_coord *P1,
							 								 const t_coord *P2, t_rotation rot);

	void MGeom_GetWinkel12ABR ( t_real *result, t_real *Alpha, t_real *Beta,
						 									t_rotation rot);

#endif


