// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
//
// gliste.h && gliste.cc
// A generic list-class based on the template-class Liste
// solved with the #define command !
// A useful solution for the dumm Microsoft-C++ V 1.51 Compiler !!!
// Because the MSVC V 1.51 compiler do not support templates,
// the template structure must be shifted arround.
// 
// 
// Suggest you want to have a char List named  CharListe !
// Write a file named CharListe.h like this :
//
// #ifndef _CHARLISTE_H
//   #define _CHARLISTE_H
//
//   #define GENERIC_TYPE char
//   #define GENERIC_TYPE_NAME(a) Char ## a 
//
//   #include "gliste.h"
//
//   #undef  GENERIC_TYPE
//   #undef  GENERIC_TYPE_NAME
// #endif
// 

// 
// To compile the definition of CharListe,
// write a file named CharListe.cc like this :
//
//      #define GENERIC_TYPE char
//   #define GENERIC_TYPE_NAME(a) Char ## a 
//
//   #include "gliste.hcc"
//
//   #undef  GENERIC_TYPE
//   #undef  GENERIC_TYPE_NAME
// 


#undef  G_DEF
#define G_DEF(a,b) a(b)

// liste.h  
// Virtual Mechanismus ausschliesslich fuer den Borland-C++ Version 3.1-
// Compiler entfernt und den WATCOM-C++ Compiler < Version 10.0 ( too bugy )!!!!
//
// Original von
// Martin Schader & Stefan Kuhlins : Programmieren in C++, Springer Verlag,
// ISBN-3-540-56524-8
//
// Modifizierungen :
//   fuegeEin, loesche und beide Indexoperatoren verwenden nun die
//   doppelt verkettete Liste mit dem aktuellen Zeiger und Indize !!!
// Von :
// Sven Goethel, Stapenhorststr.35a, 33615 Bielefeld, 0521-139228
//
// Modifizierungen :
//   operator !(), operator int()
//
// istElement uebertragen von Menge.h von Sven Goethel.
// Referenz2Index eingefuegt von Sven Goethel.
/*
 *
 *  $Log: liste.h $
 *  Revision 1.9  1995/04/07 16:54:51  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.8  1995/04/04 10:38:18  Sven_Goethel
 *  Listen Index-Operator nun Strenger fuer constante Listen (
 *    Rueckgabewert auch hier konstant !! )
 *  Revision 1.7  1995/04/04 10:37:26  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.6  1995/03/07 05:59:28  sg
 *  WATCOM Version < 10.0 bedingte compilierung ergaenzt !!!
 *  Revision 1.5  1995/03/06 18:49:56  ks
 *  Bedingte compilation jetzt auch fuer WATCOM C++ Version < 10.0
 *  Revision 1.4  1994/12/15 15:28:10  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.3  1994/12/15 15:26:57  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.2  1994/12/15 15:24:36  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.1  1994/12/15 15:18:40  Sven_Goethel
 *  Initial revision
 *
*/


  # include <stdlib.h>
  # include <stdio.h>
  # include <assert.h>
  # include "interror.h"

  // Klasse Liste
  // Der Typ der Listenelemente ist beliebig
  //
  // 1. Element hat den Index 0 !!!!!
  //
  // Elementfunktionen:
  //
  // Falsche Indexoperatoren rufen exit(1), mit Angabe der Zeilennummer auf.
  //
    // int fuegeEin(const Tt& x, int i)
  //     Erzeugt ein neues Listenelement, welches <Tt> beinhaltet
  //     und fuegt es als (i+1)te Komponente in die Liste ein.
  //     liefert 1, falls erfolgreich, 0 sonst
  // int loesche(int i)
  //     loescht (i+1)te Komponente aus der Liste
  //     liefert 1, falls erfolgreich, 0 sonst
  // int laenge()
  //     liefert die aktuelle Anzahl der Listenelemente
  // der Indexoperator [] const ist fuer const und nicht-const
  //     Listenobjekte definiert
  //     Ein Zugriff mit falschem Index ruft exit(1) auf
  // der NOT-Operator ! gibt einen int-Wert ungleich Null
  //     zurueck, wenn die Liste leer ist, sonst wird Null
  //     zurueckgeliefert
  // der Umwandlungsoperator 'int()' ist das Gegenstueck zum
  //     NOT-Operator, d.h. er liefert einen int-Wert ungleich
  //     Null bei nicht leerer Liste, und Null bei leerer Liste
  //  !! Vorsicht: wird eine Listeinstanz in einem Zusammen-
  //  !! hang benutzt, indem ein int-Wert erwartet wird, so wird
  //  !! dieser Umwandlungsoperator aufgerufen
  //
  //  istElement(const Tt&, int =0) somit ist ein Test ob das Element
  //  schon vorhanden ist moeglich.
  //  Es wird von i bis laenge-1 gesucht.
  //  RETURN : ListenIndize, wenn gefunden;
  //           bzw -1, wenn nicht gefunden !!!
  //
  // int Referenz2Index(const Tt& a)
  // Es wird ein Element mit der Referenz a in der Liste gesucht !
  // RETURN : -1  : nicht gefunden.
  //          >=0 : gefunden, index des Elementes. Sven Goethel
  //
  //
  // Iteratoren:
  //
  // ListElem *anfang()
  //     liefert einen Zeiger auf den Listenanfang
  // ListElem *iter_fw()
  //     positioniert den Zeiger auf das folgende Element
  //     liefert am Ende der Liste 0
  // ListElem *iter_bw()
  //     positioniert den Zeiger auf das vohergehende Element
  //     liefert am Anfang der Liste 0


    class G_DEF(GENERIC_TYPE_NAME, ListElem)
    {
      public:
                G_DEF(GENERIC_TYPE_NAME, ListElem)
        (const GENERIC_TYPE & e, G_DEF(GENERIC_TYPE_NAME, ListElem)* v = 0, 
         G_DEF(GENERIC_TYPE_NAME, ListElem)* n = 0
        )
        : element(*((GENERIC_TYPE *)(&e))), vorg(v), nachf(n) 
                { 
                  ;
                  #ifdef __LISTE_PARANOIA__
                        if(vorg) 
                        {
                            if(vorg->nachf!=this) INT_ERR(__LINE__);
                        }
                        if(nachf) 
                        {
                            if(nachf->vorg!=this) INT_ERR(__LINE__);
                        }
          #endif
                }
        GENERIC_TYPE element;
        G_DEF(GENERIC_TYPE_NAME, ListElem)* vorg;
        G_DEF(GENERIC_TYPE_NAME, ListElem)* nachf; // dbl lst.
    };

    class G_DEF(GENERIC_TYPE_NAME, Liste)
    {
      public:
                G_DEF(GENERIC_TYPE_NAME, Liste) ()
        : start(0), anzahl(0), aktZgr(0)   { anfang(); }
        #if ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) )
                  virtual 
        #endif
                ~G_DEF(GENERIC_TYPE_NAME, Liste) () { dest(); }
        G_DEF(GENERIC_TYPE_NAME, Liste) (const G_DEF(GENERIC_TYPE_NAME, Liste) & m) 
        : start(0), anzahl(m.anzahl) { copy(m); }

        #if ( ( __BCPLUSPLUS__ > 0x0310 || !defined(__BCPLUSPLUS__) ) &&                      ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) ) )
                  virtual
        #endif
        int fuegeEin(const GENERIC_TYPE&, int = 0);

        int fuegeEin(const G_DEF(GENERIC_TYPE_NAME, Liste)& AL, int Pos = 0) ;

        #if ( ( __BCPLUSPLUS__ > 0x0310 || !defined(__BCPLUSPLUS__) ) &&                      ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) ) )
                  virtual
        #endif
                int loesche(int);

        G_DEF(GENERIC_TYPE_NAME, Liste)& operator= 
          (const G_DEF(GENERIC_TYPE_NAME, Liste) &);

        void operator+=  (const G_DEF(GENERIC_TYPE_NAME, Liste)& AL)
        {
            if (!fuegeEin (AL, laenge ()))    INT_ERR (__LINE__);
        }
        int operator !() const
        {
            return (anzahl == 0);
        }
        operator int() const
        {
            return !(anzahl == 0);
        }
        #if ( ( __BCPLUSPLUS__ > 0x0310 || !defined(__BCPLUSPLUS__) ) &&                      ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) ) )
          int operator == (const G_DEF(GENERIC_TYPE_NAME, Liste)&) const;
          int operator != (const G_DEF(GENERIC_TYPE_NAME, Liste)& L) const
          {
            return !(G_DEF(GENERIC_TYPE_NAME, Liste)::operator == (L));
          }
        #endif

        #if ( ( __BCPLUSPLUS__ > 0x0310 || !defined(__BCPLUSPLUS__) ) &&                      ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) ) )
                  virtual
        #endif
                const GENERIC_TYPE& operator[](int i) const
                { return *((const GENERIC_TYPE * const )(hole_element(i))); }

        #if ( ( __BCPLUSPLUS__ > 0x0310 || !defined(__BCPLUSPLUS__) ) &&                      ( __WATCOMC__ >= 1000 || !defined(__WATCOMC__) ) )
                  virtual
        #endif
                GENERIC_TYPE& operator[](int i)
                { return *((GENERIC_TYPE * )(hole_element(i))); }

        int laenge() const { return anzahl; }
        int istElement(const GENERIC_TYPE&, int =0) const;
        int Referenz2Index(const GENERIC_TYPE&) const;

        #ifdef __LISTE_PARANOIA__
          void ParanoiaCheck() const;
        #endif

      protected:
        void anfang() const 
        { 
          *((int *)(&aktInd)) = 0; 
          *((G_DEF(GENERIC_TYPE_NAME, ListElem)**)(& aktZgr)) = start; 
        }

        void iter_fw() const 
        { 
          if(aktZgr != 0) 
          {
            *((int *)(&aktInd)) += 1; 
            *((G_DEF(GENERIC_TYPE_NAME, ListElem)**)(& aktZgr)) = aktZgr->nachf;
          }
          else INT_ERR(__LINE__);
        }

        void iter_bw() const 
        { 
          if(aktZgr != 0) 
          {
            *((int *)(&aktInd)) -= 1; 
            *((G_DEF(GENERIC_TYPE_NAME, ListElem)**)(& aktZgr)) = aktZgr->vorg;
          }
          else INT_ERR(__LINE__);
        }

			GENERIC_TYPE* hole_element(int i) const;       

      private:
        void dest();
        void copy(const G_DEF(GENERIC_TYPE_NAME, Liste)&);
        G_DEF(GENERIC_TYPE_NAME, ListElem)* start;
        int anzahl;
        G_DEF(GENERIC_TYPE_NAME, ListElem)* aktZgr;
        int aktInd;
    };

