// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
//
/*************************************************************************/
/*
 *  Datei           : jauio.cpp
 *  Inhalt          : eigene io funktionen
 *  Programmierer   : Sven Goethel
 *					  Stapenhorststr.35a
 *					  33615 Bielefeld
 *					  0521/139228
 *  Erstellungsdatum: 05.05.1994
 *  nderungsdatum  : 28.07.1994
 *  Projekt         : fxmcnv
 *  Verzeichnis     :
 *  Dokumentation   : fxmcnv.doc
 *
 *
 *  $Log: jauio.cc $
 *  Revision 1.4  1995/04/07 16:54:49  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:25  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:05  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:39  Sven_Goethel
 *  Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include "jauio.h"

/*DOCST------------------------------------------------------------------------------

	Eigen IO Funktion
	----------------------------------------
	char *GetFileInBuffer(char *fName)

	- Beschreibung
	--------------
	Es wird der Versuch unternommen eine Text-Datei komplett in den Speicher
	einzuladen.

	- Parameter
	-----------
	E:Dateiname

	- allgemeine Ein- und Ausgabeeinheiten
	--------------------------------------
	keine

	- Returncode
	------------
	OK : SpeicherAdresse.
		 Der Speicher muss spter mittels free wieder freigegeben werden.

	FAlSE : NULL

	- Historie
	----------
	28.7.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
char *GetFileInBuffer(char *fName)
{
  FILE *fTmp=NULL;
  char *Buffer=NULL;
  unsigned long BufferLength, BufferSegLength, i, ReadBytes;

  // Nicht groesser als ein Segment !!!!!!!
  BufferLength=CORELEFT();
  if(BufferLength>=64000u) BufferSegLength=64000u;
  else BufferSegLength=BufferLength;

  if(BufferLength==0) {
	printf("<NCDB_CUT> No Memory found....\n");
	INT_ERR(__LINE__);
  }
  if ( ( Buffer=(char *)malloc(BufferLength) ) == NULL ) {
	printf("<NCDB_CUT> Could not allocate found Memory ....\n");
	INT_ERR(__LINE__);
  }

  if( (fTmp=fopen(fName,"rt")) == NULL )
  {
	INT_ERR(__LINE__);
  }

  // kopieren !!!!
  i=0;
  while ( ( ReadBytes=fread(&Buffer[i], 1,
			 (BufferLength-i>BufferSegLength)?BufferSegLength:BufferLength-i,
			 fTmp)
		  ) > 0
		)
  {
	i+=ReadBytes;
	assert(i<=BufferLength);
  }

  if(feof(fTmp)==0)
  {
	free(Buffer);
	Buffer=NULL;
  } else {
	Buffer[i]=0;
	realloc(Buffer, i+1);
  }


  fclose(fTmp);

  return Buffer;
}

