
#ifndef _MATHPLUSS_H
  #define _MATHPLUSS_H 

	#include <math.h>
	#include <limits.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include "metatype.h"

	typedef long double t_transformation_matrix[4][4];

	/* PROTOTYPEN */

	double atan2_coord(t_coord sp, t_coord ep);
	t_real distance(const t_coord &sp, const t_coord &ep);
	void transform_coord( const t_orient &or, t_coord & point ) ;
	void orientation_to_matrix ( const t_orient &or, t_transformation_matrix &goal );
	void transform_coord( const t_transformation_matrix &matrix, t_coord & point ); 
	int matrix_to_orientation(
					const t_transformation_matrix &matrix,
					t_orient &or_1, t_orient &or_2,
					t_coord &sin_1, t_coord &sin_2,
					t_coord &cos_1, t_coord &cos_2); 
	void matrix_multiplication( const t_transformation_matrix &mat1,
															const t_transformation_matrix &mat2,
															t_transformation_matrix &goal);
	t_coord trafo_xyz2incl(t_orient &or);
	double BOGEN(t_angle x);
	t_coord trafo_xyz2incl(t_orient &or);

#endif




