/*************************************************************************/
// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
//
/*
 *  Datei           : MyYYScan.h
 *  Inhalt          : Deklaration fuer Klassen
 *              o MyYYScan
 *  Programmierer   : Sven Goethel
 *            Stapenhorststr.35a
 *            33615 Bielefeld
 *            0521/139228
 *  Erstellungsdatum: 21.07.1994
 *  nderungsdatum  :
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 *  $Log: myyyscan.h $
 *  Revision 1.1  1996/04/26 07:56:11  Sven_Goethel
 *  Initial revision
 *
 *  Revision 1.4  1995/04/07 16:54:55  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:34  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:20  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:43  Sven_Goethel
 *  Initial revision
 *
 */
/*************************************************************************/

#ifndef _MYYYSCAN_H
  #define _MYYYSCAN_H

  # include "interror.h"
  # include <stdio.h>

  template<class Tt> class MyYYScan : public Tt {
    public:
      MyYYScan(FILE *input) : Tt()
      { setinput(input); }

      MyYYScan(FILE *input, int sz) : Tt(sz)
      { setinput(input); }

      MyYYScan(const char *input) : Tt()
      { setinput(input); }

      MyYYScan(const char *input, int sz) : Tt(sz)
      { setinput(input); }

      void setinput(const char *input)
      {
	    InputBuffer=input;
	    InputBufferPos=0;
	    InputBufferLen=strlen(InputBuffer);
	    Tt::setinput(NULL);
      }

      void setinput(FILE * in)
      {
	    InputBufferLen=0;
	    InputBuffer=NULL;
	    InputBufferPos=0;
	    Tt::setinput(in);
      }


    protected:
      virtual int yygetc()
      {
	    if(!InputBuffer) return getc(yyin);
	    else {
	    if(sizeof(long)>=sizeof(char *))
	    {
	      #ifdef NDEBUG
	      long l_test=((long)InputBuffer+(InputBufferPos++));
	      char *ptrTest=(char *)l_test;
	      char c_test=*ptrTest;
	      return c_test;
	      #else
	      return * ( (char *) ( (long)InputBuffer+(InputBufferPos++) ) ) ;
	      #endif
	    }
	    else return InputBuffer[(int)(InputBufferPos++)];
	    }
      }

      virtual int yyfseek(long offset, int whence)
      {
	    if(!InputBuffer) return fseek(yyin, offset, whence);
	    else {
	    switch(whence) {
	      case SEEK_SET:    InputBufferPos=offset;
		      break;
	      case SEEK_CUR:    InputBufferPos+=offset;
		      break;
	      case SEEK_END:    InputBufferPos=InputBufferLen
			      -1
			      -offset;
		      break;
	      default    :  INT_ERR(__LINE__);
		      break;
	    }
	    return 0;
	    }
      }

      virtual long yyftell()
      {
	    if(!InputBuffer) return ftell(yyin);
	    else return InputBufferPos;
      }

    private:
      const char *InputBuffer;
      unsigned long InputBufferPos;
      unsigned long InputBufferLen;
  };

  /**************************************************************************/
  /**************************************************************************/
  /**************************************************************************/

#endif

