// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
//
/*************************************************************************/
/*
 *  Datei           : strclass.cc
 *  Inhalt          : Definition fuer Funktionen der Klasse :
 *                        o StrClass
 *  Programmierer   : Sven Goethel
 *                    Herforder 54
 *                    33602 Bielefeld
 *                    0521/139228
 *                    email: s_goethel@bielefeld.netsurf.de
 *                  
 *  Erstellungsdatum: 05.05.1994
 *  nderungsdatum  : 16.10.1994
 *  Projekt         : ...
 *  Verzeichnis     :
 *  Dokumentation   : ...
 *
 *    PUBLIC DOMAIN ....
 *
 *  $Log: strclass.cc $
 *  Revision 1.4  1995/04/07 16:54:57  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:36  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:28  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:45  Sven_Goethel
 *  Initial revision
 *
 */
/*************************************************************************/

# include "strclass.h"

const char *StrClass::TmpFileName="StrClass.tmp";

  ostream& operator<< (ostream& OS, StrClass& str)
    {
      if(str.StrPtr==0) OS << "(null)" ;
      else OS << str.StrPtr ;
      return OS;
    }

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse StrClass
    ----------------------------------------
    int ::laenge(void) const

    - Beschreibung
    --------------
    Rueckgabe von strlen.

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keine

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int StrClass::laenge(void) const { return ( StrPtr!=NULL?strlen(StrPtr):0 ); }

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse StrClass
    ----------------------------------------
    void ::copy(const char *m)

    - Beschreibung
    --------------
    Kopierfunktion

    - Parameter
    -----------
    E: m         Source

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keine

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
void StrClass::copy(const char *m)
{
  if(m!=NULL)
  {
    if ( ( StrPtr=new char[strlen(m)+1] ) == NULL )
    {
      fprintf(stderr,"\n Speicherfehler.");
      fprintf(stderr,"\n Es wurde versucht ein StringClass-Element fuer einen String");
      fprintf(stderr,"\n mit der Laenge : %d zu erzeugen.\n", strlen(m));
      INT_ERR(__LINE__);
    }
    strcpy(StrPtr, m);
  } else StrPtr=NULL;
}

/*DOCST------------------------------------------------------------------------------

    Elementfunktion der Klasse StrClass
    ----------------------------------------
    void ::dest()

    - Beschreibung
    --------------
    Freigabe der Instanz

    - Parameter
    -----------
    keine

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keine

    - Historie
    ----------
    21.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
void StrClass::dest()
{
  if(StrPtr)
  {
    delete[] StrPtr;
    StrPtr=NULL;
  }
}

void StrClass::StrCat(const StrClass &m)
{                  
   if(!m.StrPtr) return;
   
   char *Buffer;
   unsigned int BufferLength=1;

   if(StrPtr)                           
     BufferLength+=strlen(StrPtr);
     
   if(m.StrPtr)                           
     BufferLength+=strlen(m.StrPtr);
   else INT_ERR(__LINE__);  
   
   if ( ( Buffer=new char[BufferLength] ) == NULL ) INT_ERR(__LINE__);
   if(StrPtr)
     strcpy(Buffer, StrPtr);
   else Buffer[0]=0;  
   strcat(Buffer, m.StrPtr);
   
   delete[] StrPtr;
   StrPtr=Buffer;
   
   /* too much ...
   dest();
   copy(Buffer);
   delete[] Buffer;
   */
}

void StrClass::AssignDouble(double m) 
{ char buf[256]; sprintf(buf,"%.0lf", m); dest(); copy(buf); }

/*DOCST------------------------------------------------------------------------------

    Zuweisungsoperatoren der Klasse StrClass
    ----------------------------------------
    StrClass& ::operator=(const StrClass &m)
    StrClass& ::operator=(const char *StrPtr)

    - Beschreibung
    --------------
    Zuweisungsoperator

    - Parameter
    -----------
    E: m        Source
    oder
    E: StrPtr    Source

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keine

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
StrClass& StrClass::operator=(const StrClass &m)
{
  if(this!=&m)
  {
     dest();
     copy(m.StrPtr);
  }
  return *this;
}

StrClass& StrClass::operator=(const char *StrPtr)
{
  dest();
  copy(StrPtr);
  return *this;
}

/*DOCST------------------------------------------------------------------------------

    Boolesche Operatoren der Klasse StrClass
    ----------------------------------------
    int ::operator==(const StrClass &m) const
    int ::operator!=(const StrClass &m) const
    int ::operator>=(const StrClass &m) const
    int ::operator<=(const StrClass &m) const
    int ::operator>(const StrClass &m) const
    int ::operator<(const StrClass &m) const

    - Beschreibung
    --------------
    Vergleichsoperator

    - Parameter
    -----------
    E: m         Operand No.2

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    keine

    - Historie
    ----------
    11.5.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int StrClass::operator==(const StrClass &m) const
{
  if ( StrPtr==NULL )
  {
    if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 )
      return 1;
    else return 0;
  } 
  if ( m.StrPtr == NULL ) return 0;
  if ( strcmp(StrPtr, m.StrPtr) == 0 )
    return 1;
  else return 0;
}

int StrClass::operator!=(const StrClass &m) const
{
  return !(*this==m);
}

int StrClass::operator>=(const StrClass &m) const
{
  if ( StrPtr==NULL || strcmp(StrPtr,"")==0 )
  {
    if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 ) return 1;
    else return 0;
  }

  if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 ) return 1;

  int b=strcmp(StrPtr, m.StrPtr);
  if ( b == 0 || b>0 )
    return 1;
  else return 0;
}

int StrClass::operator<=(const StrClass &m) const
{
  if ( StrPtr==NULL || strcmp(StrPtr,"")==0 ) return 1;

  if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 ) return 0;

  int b=strcmp(StrPtr, m.StrPtr);
  if ( b == 0 || b<0 )
    return 1;
  else return 0;
}

int StrClass::operator>(const StrClass &m) const
{
  if ( StrPtr==NULL || strcmp(StrPtr,"")==0 ) return 0;

  if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 ) return 1;

  if ( strcmp(StrPtr, m.StrPtr) > 0 )
    return 1;
  else return 0;
}

int StrClass::operator<(const StrClass &m) const
{
  if ( StrPtr==NULL || strcmp(StrPtr,"")==0 ) return 1;

  if ( m.StrPtr==NULL || strcmp(m.StrPtr,"")==0 ) return 0;

  if ( strcmp(StrPtr, m.StrPtr) < 0 )
    return 1;
  else return 0;
}
   
int StrClass::Chk4SubStr(const StrClass &SubStr, int StartIndex)
{                                                              
  if ( StrPtr==NULL || strcmp(StrPtr,"")==0 ) return -1;
  
  int i, l=laenge(), l2=SubStr.laenge();
  
  for (i=StartIndex; i<l; i++)
  {                                    
    if(strncmp(&(StrPtr[i]),SubStr.StrPtr,l2)==0) return i;
  }
  return -1;
}

int StrClass::DelSubStr(const StrClass &SubStr, int StartIndex)
{
  int i=Chk4SubStr(SubStr, StartIndex);
  
  if(i>=0)
  {
    int l=laenge();
    int l2=SubStr.laenge();
    char *newstr=new char[l-l2+1];
    if(!newstr) INT_ERR(__LINE__);
    strncpy(newstr, StrPtr, i);
    newstr[i]=0;
    strcat(newstr, &(StrPtr[i+l2]));
    delete[] StrPtr;
    StrPtr=newstr;
  }
  return i;
}

bool StrClass::InsertSubStr(const StrClass &SubStr, int Index)
{
	int l=laenge();
	int l2=SubStr.laenge();
	
	if(l<Index) return false;
	
	char *newstr=new char[l+l2+1];
	if(!newstr) INT_ERR(__LINE__);
	                           
	if(Index>0) strncpy(newstr, StrPtr, Index);
	
	newstr[Index]=0;
	strcat(newstr, SubStr.StrPtr);
	
	if(Index<l)	strcat(newstr, &(StrPtr[Index]));
	
	delete[] StrPtr;
	StrPtr=newstr;
	return true;
}

int StrClass::DelAllSubStr(const StrClass &SubStr)
{
  int i=0;
  
  while(DelSubStr(SubStr)>=0) i++;
  
  return i;
}             

int StrClass::SubstSubStr(const StrClass &SubStr, const StrClass &Substitute, int StartIndex)
{
  int i=StartIndex;
  
  if((i=Chk4SubStr(SubStr,i))>=0) 
  {
    if(DelSubStr(SubStr, i)<0) INT_ERR(__LINE__);
	if(InsertSubStr(Substitute, i)==false) INT_ERR(__LINE__);
  }
  
  return i;
}

int StrClass::SubstAllSubStr(const StrClass &SubStr, const StrClass &Substitute)
{
  int i=0;
  
  while(SubstSubStr(SubStr,Substitute)>=0) i++;
  
  return i;
}

void StrClass::DelAllXtraWhiteSpaces()
{
	SubstAllSubStr("  "," "); // blank blank
	SubstAllSubStr("		"," "); // tab tab
	SubstAllSubStr(" 	"," ");  // blank tab
	SubstAllSubStr("	 "," "); // tab blank          
	if(StrPtr && strlen(StrPtr)==1 && ( StrPtr[0]==' ' || StrPtr[0]=='	' ) ) dest();
}


   
/***************************************************************************/
/***************************************************************************/

/*DOCST------------------------------------------------------------------------------

    Allgemeine String - File Funktionen der Klasse StrClass
    -------------------------------------------------------
    int ::ChkStringInFile(const StrClass &FName)

    - Beschreibung
    --------------
    Testet ob der String this->StrPtr in der Datei fPtr enthalten ist.

    - Parameter
    -----------
    A:FName            Name der zu testenden Datei

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Nichtgefunden
    n - n>0 n * Gefunden .

    - Historie
    ----------
    13.7.1994 Sven Goethel
    26.7.1994 Sven Goethel eingebracht in StrClass

------------------------------------------------------------------------------DOCEND*/
int StrClass::ChkStringInFile(const StrClass &FName)
{
  return DoStringInFile(FName, 0);
}


/*DOCST------------------------------------------------------------------------------

    Allgemeine String - File Funktionen der Klasse StrClass
    -------------------------------------------------------
    int ::DelStringInFile(const StrClass &FName)

    - Beschreibung
    --------------
    Loescht den String this->StrPtr in der Datei fPtr, falls vorhanden.

    - Parameter
    -----------
    A:FName            Name der zu testenden Datei

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Nichtgefunden
    n - n>0 n * Gefunden und n * geloescht.

    - Historie
    ----------
    26.7.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int StrClass::DelStringInFile(const StrClass &FName)
{
  return DoStringInFile(FName, 1);
}

/*DOCST------------------------------------------------------------------------------

    Allgemeine String - File Funktionen der Klasse StrClass
    -------------------------------------------------------
    int ::DoStringInFile(const StrClass &FName, int Delete)

    - Beschreibung
    --------------
    Loescht den String this->StrPtr in der Datei fPtr, falls vorhanden.

    - Parameter
    -----------
    E/A:FName            Name der zu testenden Datei
    E:Delete            Flag ob der zu suchende String geloescht werden soll

    - allgemeine Ein- und Ausgabeeinheiten
    --------------------------------------
    keine

    - Returncode
    ------------
    0 - Nichtgefunden
    n - n>0 n * Gefunden [ und n * geloescht ]* .

    * falls Delete>0

    - Historie
    ----------
    26.7.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int StrClass::DoStringInFile(const StrClass &FName, int Delete)
{
  char *Buffer=NULL;
  unsigned int BufferLength=0, ReadBytes=0;
  int i=0, Bytes2Check=0;
  int len=strlen(StrPtr), found=0;
  FILE *fPtr=NULL, *fTmp=NULL;

  if ( (fPtr=fopen(FName.GetStrPtr(),"rt")) != NULL )
  {
    if(Delete)
    {
      if ( (fTmp=fopen(TmpFileName,"wt")) == NULL )
      {
        INT_ERR(__LINE__);
      }
    }

    // Nicht groesser als ein Segment !!!!!!!
    if(CORELEFT()>=64000u) BufferLength=64000u;
    else BufferLength=(unsigned int)(CORELEFT());

    if(BufferLength==0) {
      fprintf(stderr, "<STRCLASS> No Memory found....\n");
      INT_ERR(__LINE__);
    }
    if ( ( Buffer=(char *)malloc((int)BufferLength) ) == NULL ) {
      fprintf(stderr, "<STRCLASS> Could not allocate found Memory ....\n");
      INT_ERR(__LINE__);
    }

    // suchen
    // Am Anfang kein Rest !!!!!!!!!!!!!!!!
    // Bytes2Check enthaelt ab hier die noch zu testende Anzahl von chars.
    Bytes2Check=0;
    // Happen am Ende des Restes einlesen !
    while ( ( ReadBytes = fread ( &(Buffer[Bytes2Check]), 1,
                                  BufferLength-Bytes2Check, fPtr
                                )
            ) > 0
          )
    {
      // auch die neu gelesenen bytes muessen geprueft werden ....
      Bytes2Check+=ReadBytes;
      // Happen untersuchen, byte fuer byte
      // von Anfang an !!!!
      i=0;
      while ( len <= Bytes2Check )
      {
        if(strncmp(&(Buffer[i]), StrPtr, len)==0)
        {
          found++; // gefunden
          Bytes2Check-=len;
          if(Delete)
          {
            // bis zum gefundenen String schreiben.
            fwrite(Buffer, 1, i, fTmp);
          }
          // rest wieder zum Anfang kopieren
          if(Bytes2Check>0)
            memmove(Buffer, &(Buffer[i+len]), Bytes2Check);
          i=0;
        } else {
          i++;
          Bytes2Check--;
        }
      }
      if(i>0)
      {
        if(Delete)
        {
          // nicht erkanntes kopieren ....
          fwrite(Buffer, 1, i, fTmp);
        }
        // Rest zum Anfang kopieren !!!
        if ( Bytes2Check > 0 )
          memmove(Buffer, &(Buffer[i]), Bytes2Check);
      }
    } // while gelesen
    if(Bytes2Check>0 && Delete)
      fwrite(Buffer, 1, Bytes2Check, fTmp); // und den rest kopieren ....

    fclose(fPtr);

    if(Delete)
    {
      fclose(fTmp);

      // Tempfile -> Originalfile kopieren .....
      if( (fPtr=fopen(FName.GetStrPtr(),"wt")) == NULL )
      {
        INT_ERR(__LINE__);
      }
      if( (fTmp=fopen(TmpFileName,"rt")) == NULL )
      {
        INT_ERR(__LINE__);
      }

      // kopieren !!!!
      while ( ( ReadBytes=fread(Buffer, 1, BufferLength, fTmp) ) > 0 )
        fwrite(Buffer, 1, ReadBytes, fPtr);

      fclose(fTmp);
      fclose(fPtr);
      remove(TmpFileName);
    }
  }
  free(Buffer);
  return found;
}

StrClass operator+(const StrClass &m, const StrClass &n)
{
  StrClass sum=m;
  sum+=n;
  return sum;
}

/***************************************************************************/
/***************************************************************************/
