// MKS LEX C++ Library function
// int yymapch(int delim, int esc) : read C++ escaped character
// Copyright 1991 Mortice Kern Systems Inc.
// All rights reserved.
/*
 *
 *  $Log: yymapch.cc $
 *  Revision 1.1  1995/05/12 18:32:18  Sven_Goethel_DFP
 *  Initial revision
 *  Revision 1.4  1995/04/07 16:54:58  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:38  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:32  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:46  Sven_Goethel
 *  Initial revision
 *
*/

#include "lex_yy.hpp"

int
yy_scan::yymapch(int delim, int esc)
{
	register int c, octv, n;

	if ((c = input()) == delim)
		return (EOF);
	if (c<=0 || c=='\n') {
		yyerror("unterminated string");
		unput(c);
		return (EOF);
	}
	if (c != esc)
		return (c);
	switch (c = input()) {
	case 'a':			/* alert */
		return '\a';
	case 'b':			/* backspace */
		return '\b';
	case 'v':			/* vertical tab */
		return '\v';
	case '?':			/* \? is one ? */
		return '?';
	case 't':
		return ('\t');
	case 'n':
		return ('\n');
	case 'f':
		return ('\f');
	case '\"': case '\'':
		return (c);
	case 'r':
		return ('\r');
	case 'x':
		for (n = 1, octv = 0; n<= 3; n++) {
			if ((c = input()) >= '0' && c <= '9')
				c -= '0';
			else if (c >= 'a' && c <= 'f')
				c = (c - 'a') + 10;
			else if (c >= 'A' && c <= 'F')
				c = (c - 'A') + 10;
			else
				break;
			octv = octv*16 + c;
		}
		unput(c);
		if (n == 1)			/* no higits */
			return 'x';
		return octv;
	case '0': case '1': case '2': case '3':
	case '4': case '5': case '6': case '7':
		octv = c-'0';
		for (n = 1; (c = input())>='0' && c<='7' && n<=3; n++)
			octv = octv*010 + (c-'0');
		unput(c);
		return (octv);
	case '\n':
		return  yymapch(delim, esc);
	}
	return (c);
}
